C A simple program to calculate the date of Easter for a given period of time (year1 to year2)
C The list with the Easter dates is written to the file easter.txt
C Uses the program EASTER from "Interactive Fortran 77 - A Hands on Approach" as subroutine

      PROGRAM EASTER2

      INTEGER YEAR, YEAR1, YEAR2, MONTH, LUNA
      CHARACTER*5 SMONTH

      WRITE (*, *) 'Calculate Easter for a given period:'
      WRITE (*, "(A14, $)") ' First year = '
      READ *, YEAR1
      WRITE (*, "(A14, $)") ' Last year  = '
      READ *, YEAR2
      IF (YEAR2.GE.YEAR1) THEN
        OPEN(UNIT=1, FILE='easter.txt')
        WRITE (1, "(A19, 1X, I4, 1X, A2, 1X, I4)")
     +    'Date of Easter from', YEAR1, 'to', YEAR2
        WRITE (1, *)
        DO YEAR = YEAR1, YEAR2
          CALL EASTER(YEAR, MONTH, LUNA)
          IF (MONTH.EQ.3) THEN
            SMONTH = 'March'
          ELSE
            SMONTH = 'April'
          ENDIF
          WRITE (1, "(I4, 5X, A5, 1X, I2)") YEAR, SMONTH, LUNA
        ENDDO
        CLOSE(UNIT=1)
        WRITE (*, *) 'List with Easter dates in file: easter.txt'
      ENDIF

      END

C *************************************************
C * Subroutine to calculate Easter for a given year
C *************************************************

      SUBROUTINE EASTER(YEAR, MONTH, LUNA)

      INTEGER YEAR, METCYC, CENTRY, ERROR1, ERROR2, DAY, MONTH
      INTEGER EPACT, LUNA

C CALCULATING THE YEAR IN THE 19 YEAR METONIC CYCLE-METCYC
      METCYC = MOD(YEAR, 19) + 1
      IF (YEAR.LE.1582) THEN
        DAY = (5 * YEAR) / 4
        EPACT = MOD(11 * METCYC - 4, 30) + 1
      ELSE
C CALCULATING THE CENTURY-CENTRY
        CENTRY = (YEAR / 100) + 1
C ACCOUNTING FOR ARITHMETIC INACCURACIES
C IGNORES LEAP YEARS ETC.
        ERROR1 = (3 * CENTRY / 4) - 12
        ERROR2 = ((8 * CENTRY + 5) / 25) - 5
C LOCATING SUNDAY
        DAY = (5 * YEAR / 4) - ERROR1 - 10
C LOCATING THE EPACT (FULL MOON)
        EPACT = MOD(11 * METCYC + 20 + ERROR2 - ERROR1, 30)
        IF (EPACT.LT.0) EPACT = 30 + EPACT
        IF ((EPACT.EQ.25.AND.METCYC.GT.11).OR.EPACT.EQ.24) THEN
          EPACT = EPACT + 1
        ENDIF
      ENDIF
C FINDING THE FULL MOON
      LUNA = 44 - EPACT
      IF(LUNA.LT.21) LUNA = LUNA + 30
C LOCATING EASTER SUNDAY
      LUNA = LUNA + 7 -(MOD(DAY + LUNA, 7))
C LOCATING THE CORRECT MONTH
      IF (LUNA.GT.31) THEN
        LUNA = LUNA - 31
        MONTH = 4
      ELSE
        MONTH = 3
      ENDIF

      END
